#!/bin/bash

# `make' should direct the action
if (($# == 0)); then
  make help
  exit 1
fi

if [[ "$1" == "--help" || "$1" == "-h" ]]; then
  make help
  exit 1
fi

CheckMD5s() {
      if [ "$1" = "$2" ]; then
        echo $1'='$2 $3
      else
        echo $1'!'$2 $3
	echo "ERROR: File checksums don't match. Try a manual uninstallation."
        exit 1
      fi  
}

ExistingFilesError(){
  echo;echo
  echo "ERROR: Existing file /Library/Hooks/$1 conflicts with installation"
  echo "       Since the existing file might not be from an existing CsMOSH"
  echo "       installation, installation will end now."
  echo 
  echo "       Check the existing files and type \`make help' for help."
  exit 1
}

if [ $1 = "checkroot" ]; then
  echo -n "Checking for administrator priveleges... "
  if [ ! -w "/var/log" ]; then
    echo;echo
    echo "ERROR: You must have administrator or root priveleges "
    echo "       to install or uninstall."
    exit 1
  fi
  echo "OK"
  exit 0
fi 

# Check for an existing installation
if [ "$1" = "check" ];  then
  echo -n "Checking for installation conflists... "
  cd Hooks > /dev/null
  for i in * ; do
    if [ -a "/Library/Hooks/$i" ]; then
      ExistingFilesError $i
    fi
  done
  cd ..
  echo none
  if [ -a "/etc/mach_init.d/csmosh_startuphook.plist" ]; then
    ExistingFilesError $i
  fi

  if [ -d "/Library/Hooks" ]; then
    exit 0
  fi
  mkdir /Library/Hooks
  exit 0
fi

# Check version for halfinstall
if [ "$1" = "checkversion" ]; then
  echo ""
  exit 1
fi

# Check things to see if it's safe to uninstall
if [ "$1" = "checkremove" ]; then
  shift
  echo "Checking that files haven't changed..."
  for i in $@ ; do
    if [ -a $i ]; then
      s1=`md5sum /Library/$i | awk '{ print $1 }'`
      s2=`md5sum $i | awk '{ print $1 }'`
      CheckMD5s $s1 $s2 $i
    fi
  done

  exit 0
fi
